/* cmdxhelp.inc
 * by-command extended help text descriptions.
 */

#ifndef DF3_CMDXHELP_INC
#define DF3_CMDXHELP_INC 1

static char const * const app_cmd_xhelp[] = {

 "cli: copy source axes offset target\n\n"
 "copies the {source} volume described by {axes} and {offset} to\n"
 "{target}.  {axes} may be larger than the {source}, in effect\n"
 "growing the volume, or smaller, cropping it.  \"holes\" in a\n"
 "larger {target} will be zero-filled unless the program is\n"
 "invoked with the -fill option.  {source} data can be -input\n"
 "using the \".\" notation.\n\n",

 "cli: create axes bpv target\n\n"
 "creates a new DF3 volume of the dimensions given by {axes} and\n"
 "{bpv}.  the created {target} is zero-filled unless the program\n"
 "is invoked with the -fill option.  the -input option, if given,\n"
 "triggers reading voxel data from <stdin>.\n\n",

 "cli: export source axis[:n] target\n\n"
 "writes the {source} data layer given by {axis} and optional\n"
 "offset from origin {n} to grayscale png file {target}.  the\n"
 "{source} bpv (1|2) determines the bit depth (8-bit|16-bit).\n"
 "{source} data can be -input using the \".\" notation.\n\n",

 "cli: import target axis[:n] source\n\n"
 "reads the grayscale png image data in {source} into the layer\n"
 "specified by {axis} and optional offset from origin {n} in \n"
 "{target}.  requires {target} bpv to be 2 for 16-bit image data,\n"
 "and bpv 1 for 8-bit images.  use the -gamma option to adjust\n"
 "for your screen.  using the -warnings option enables automatic\n"
 "conversions from colour and lower bit depths, and accepts\n"
 "images smaller than the layer.\n\n",

 "cli: info source [...]\n\n"
 "summarises the contents of the given {source} file(s).  invoke\n"
 "with -verbose for a full listing of voxel values and counts.\n"
 "{source} data can be -input using the \".\" notation.\n\n",

 "cli: merge target source axes offset rule [...]\n\n"
 "merges one or more {source}s into {target}.  if {target} does\n"
 "not exist, it will be created from the first {source} file's\n"
 "dimensions (and filled if option -fill was given).  {axes} and\n"
 "{offset} refer to the subvolume in {target} in which {source}\n"
 "data is merged according to {rule}.  {source} data can be\n"
 "-input using the \".\" notation.\n"
 "rules: add, and, div, mid, mod, mul, not, or, rnd, set, sub, "
 "xor.\n\n",

 "cli: mirror source axis[:n] target\n\n"
 "flips the {source} volume about the \"pivot\" given by {axis},\n"
 "at origin if {n} omitted, and writes the result to {target}.\n"
 "{source} data can be -input using the \".\" notation.\n\n",

 "cli: recode source bpv target [from to ...]\n\n"
 "recodes {source} data from any bpv to any {bpv} in {target}.\n"
 "voxels will be copied where possible, and values may be trunc-\n"
 "ated if the program is invoked with the -warnings option.  use\n"
 "the -mapfile option to provide mappings {from} the source data\n"
 "{to} the target data, and/or provide values on the command-\n"
 "line.  {from} and {to} values and ranges must fit the {bpv}s,\n"
 "and they must not overlap.  {source} data can be -input using\n"
 "the \".\" notation.\n\n",

 "cli: rotate source rvect target\n\n"
 "writes to {target} the {source} volume rotated by {rvect}.\n"
 "{rvect} is a 'x,y,z' argument (like {axes}), but values are\n"
 "limited to the four right angles, ie 0, 90, 180, and 270.\n"
 "{source} data can be -input using the \".\" notation.\n\n",

 "cli: shift source axis[:n] target\n\n"
 "shifts the {source} data along the given {axis}, round-robin\n"
 "fashion, by {n} steps (default 1), and writes the result to\n"
 "{target}; {n} may be negative, {source} data can be -input\n"
 "using the \".\" notation.\n\n",

 NULL
};

#endif

/* ------------------------------------------------------------------ *
 *  this file is part of 'df3util', part of the 'df3 tools' project.  *
 *  the content above is covered by the GPLv3+, see file COPYING.     *
 *  copyright (c) 2017 jr <creature.eternal@gmail.com>.               *
 *  all rights reserved.                                              *
 * ------------------------------------------------------------------ */
